/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ui;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import javax.swing.JOptionPane;

/**
 *
 * @author Administrator
 */
public class NewLectureFrame extends javax.swing.JFrame {

    /**
     * Creates new form NewLectureFrame
     */
    NewLectureFrame mFrame;
    String subject;
    String cohort;
    String venue;
    String date;
    String time;
    String lectureInfo = null;
    ui.MainFrame mainFrame;
    String[] lectureInfoArray;
    
    public NewLectureFrame(ui.MainFrame mainFrame1) {
        initComponents();
        mFrame = this;
        mainFrame = mainFrame1;
        this.setLocationRelativeTo(mainFrame);
        if (!mainFrame.subject.toLowerCase().equals("admin")){
            subjectLabel.setText(mainFrame.subject);
        }
        Calendar cal = Calendar.getInstance(); 
        long timeInMilli = cal.getTimeInMillis();
        SimpleDateFormat sdf1 = new SimpleDateFormat("HHmm"); 
        SimpleDateFormat sdf2 = new SimpleDateFormat("dd/MM/YY"); 
        int timeTemp = Integer.parseInt(sdf1.format(cal.getTime()));
        int minTemp = 0;
        switch ((timeTemp%100)/15) {
            case 0:
                minTemp = 0;
                break;
            case 1:
            case 2:
                minTemp = 30;
                break;
            case 3:
                minTemp = 100;
                break;
            default:
                break;
        }
        timeTemp = timeTemp/100*100 + minTemp;
        if (timeTemp >= 2345){
            timeTemp = minTemp;
            timeTextField.setText("00" + Integer.toString(timeTemp));
            timeInMilli += timeInMilli + 900*1000;
            dateTextField.setText(sdf2.format(cal.getTime()));
        }else{
            timeTextField.setText(Integer.toString(timeTemp));
            dateTextField.setText(sdf2.format(cal.getTime()));
        }
        WindowListener exitListener = new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                mainFrame.setFocusableWindowState(true);
                mainFrame.setEnabled(true);
                mFrame.dispose();
            }
        };
        mFrame.addWindowListener(exitListener);
    }


    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        cohortComboBox = new javax.swing.JComboBox<>();
        jLabel3 = new javax.swing.JLabel();
        venueComboBox = new javax.swing.JComboBox<>();
        jLabel4 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        dateTextField = new javax.swing.JTextField();
        timeTextField = new javax.swing.JTextField();
        confirmButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        subjectLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("New...");
        setAlwaysOnTop(true);
        setLocation(new java.awt.Point(0, 0));
        setResizable(false);
        setType(java.awt.Window.Type.UTILITY);

        jLabel1.setText("Subject");

        jLabel2.setText("Cohort");
        jLabel2.setToolTipText("");

        cohortComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "SH1", "SH2" }));

        jLabel3.setText("Venue");

        venueComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "LT1", "LT2", "LT3", "LT4", "LT5" }));

        jLabel4.setText("Date (DD/MM/YY)");

        jLabel6.setText("Time (HHmm)");

        dateTextField.setText("DD/MM/YY");

        timeTextField.setText("HHmm");

        confirmButton.setText("Confirm");
        confirmButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                confirmButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        subjectLabel.setText("Subject");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(confirmButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(jLabel3)
                            .addComponent(jLabel4)
                            .addComponent(jLabel6)
                            .addComponent(jLabel1))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(cohortComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(venueComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(timeTextField)
                            .addComponent(dateTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
                            .addComponent(subjectLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addComponent(cancelButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(subjectLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(cohortComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(venueComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(dateTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(timeTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addGap(18, 18, 18)
                .addComponent(confirmButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(cancelButton)
                .addContainerGap())
        );

        jLabel1.getAccessibleContext().setAccessibleDescription("");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // TODO add your handling code here:
        mainFrame.setFocusableWindowState(true);
        mainFrame.setEnabled(true);
        mainFrame.toFront();
        mFrame.dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    private boolean checkInfo(){
        String[] dateData = date.split("/");
        if (dateData.length != 3){return false;}
        try{
            int temp;
            for (int i = 0; i<3 ; i++){
                temp = Integer.parseInt(dateData[i]);
                if (i == 0 && (temp<1 || temp>31)){return false;}
                if (i == 1 && (temp<1 || temp>12)){return false;}
                if (i == 2 && temp<0 ){return false;}
            }
        }catch(Exception e){return false;}
        int[] timeData = new int[2];
        if (time.length()!=4){return false;}
        try{
            timeData[0] = Integer.parseInt(time.substring(0, 2));
            if (timeData[0]<0 || timeData[0]>23){return false;}
            timeData[1] = Integer.parseInt(time.substring(2, 4));
            if (timeData[1]<0 || timeData[1]>59){return false;}
        }catch(Exception e){return false;}
        return true;
    }
            
    private void confirmButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_confirmButtonActionPerformed
        // TODO add your handling code here:
        subject = (String) subjectLabel.getText();
        cohort = (String) cohortComboBox.getSelectedItem();
        venue = (String) venueComboBox.getSelectedItem();
        date = (String) dateTextField.getText();
        time = (String) timeTextField.getText();
        if (!checkInfo()){
            JOptionPane.showMessageDialog(this, "Invalid date or time.", "Error", JOptionPane.ERROR_MESSAGE);
        }else{
            lectureInfo = cohort + "_" + subject + "_" + venue + "_" + time + "_" + date + "\n";
            data.LectureAttendance lectureAttendance = new data.LectureAttendance(lectureInfo);
            String[] lectureInfoArray = {cohort,subject,venue,time,date};
            mainFrame.addLecture(lectureInfoArray);
            mainFrame.setFocusableWindowState(true);
            mainFrame.setEnabled(true);
            mainFrame.toFront();    
            mFrame.dispose();}
    }//GEN-LAST:event_confirmButtonActionPerformed

    @Override
    public String toString(){
        return lectureInfo;
    }
            
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {

        /* Create and display the form */
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new NewLectureFrame().setVisible(true);
//            }
//        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox<String> cohortComboBox;
    private javax.swing.JButton confirmButton;
    private javax.swing.JTextField dateTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel subjectLabel;
    private javax.swing.JTextField timeTextField;
    private javax.swing.JComboBox<String> venueComboBox;
    // End of variables declaration//GEN-END:variables
}
